{% extends main_template %}

{% block locale %}{{ locale }}{% endblock %}

{% block script %}
    {% include 'seedpsd:api/templates/snippets/urlbuilder/javascript.jinja2' %}
{% endblock %}

{% block content %}
    {% include 'seedpsd:api/templates/snippets/title.jinja2' %}
    <p>{{ gettext('spectrogram:description') }}</p>
    {% include 'seedpsd:api/templates/snippets/citation.jinja2' %}

    <h2>{{ gettext('URL builder') }}</h2>
    <form action="{{ request.route_path(command) }}" method="GET" target="_blank" id="form-url-builder" class="card">
        <div class="card-body accordion accordion-flush">
            <div class="accordion-item">
                <h3 class="accordion-header" id="label-panel-source">
                    <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#panel-source" aria-expanded="true" aria-controls="panel-source">
                        {{ gettext('Data source') }}
                    </button>
                </h3>
                <div id="panel-source" class="accordion-collapse collapse show" aria-labelledby="label-panel-source">
                    <div class="accordion-body">
                        <div class="row">
                            <div class="col">
                                <div class="input-group mb-3">
                                    <span class="input-group-text" id="label-input-network">{{ gettext('parameter:network:label') }}</span>
                                    <input name="network" type="text" class="form-control" placeholder="network" aria-label="{{ gettext('parameter:network:label') }}" aria-describedby="label-input-network" onchange="generate_url();" required{% if network %} value="{{ network }}"{% endif %}>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <span class="input-group-text" id="label-input-station">{{ gettext('parameter:station:label') }}</span>
                                    <input name="station" type="text" class="form-control" placeholder="station" aria-label="{{ gettext('parameter:station:label') }}" aria-describedby="label-input-station" onchange="generate_url();" required{% if station %} value="{{ station }}"{% endif %}>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <span class="input-group-text" id="label-input-location">{{ gettext('parameter:location:label') }}</span>
                                    <input name="location" type="text" class="form-control" placeholder="location" aria-label="{{ gettext('parameter:location:label') }}" aria-describedby="label-input-location" onchange="generate_url();" required{% if location %} value="{{ location }}"{% endif %}>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <span class="input-group-text" id="label-input-channel">{{ gettext('parameter:channel:label') }}</span>
                                    <input name="channel" type="text" class="form-control" placeholder="channel" aria-label="{{ gettext('parameter:channel:label') }}" aria-describedby="label-input-channel" onchange="generate_url();" required{% if channel %} value="{{ channel }}"{% endif %}>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="accordion-item">
                <h3 class="accordion-header" id="label-panel-time">
                    <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#panel-time" aria-expanded="true" aria-controls="panel-time">
                        {{ gettext('Time period') }}
                    </button>
                </h3>
                <div id="panel-time" class="accordion-collapse collapse show" aria-labelledby="label-panel-time">
                    <div class="accordion-body">
                        <div class="row">
                            <div class="col">
                                <div class="input-group mb-3">
                                    <span class="input-group-text" id="label-input-start">{{ gettext('parameter:start:label') }}</span>
                                    <input name="date_start" type="date" class="form-control" placeholder="YYYY-MM-DD" aria-label="{{ gettext('parameter:start_date:label') }}" aria-describedby="label-input-start" onchange="generate_url();" required>
                                    <input name="time_start" type="time" class="form-control" placeholder="HH:mm:ss" aria-label="{{ gettext('parameter:start_time:label') }}" step="1" onchange="generate_url();">
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <span class="input-group-text" id="label-input-end">{{ gettext('parameter:end:label') }}</span>
                                    <input name="date_end" type="date" class="form-control" placeholder="YYYY-MM-DD" aria-label="{{ gettext('parameter:end_date:label') }}" aria-describedby="label-input-end" onchange="generate_url();" required>
                                    <input name="time_end" type="time" class="form-control" placeholder="HH:mm:ss" aria-label="{{ gettext('parameter:end_time:label') }}" step="1" onchange="generate_url();">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="accordion-item">
                <h3 class="accordion-header" id="label-panel-plot">
                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panel-plot" aria-expanded="false" aria-controls="panel-plot">
                        {{ gettext('Plot configuration') }}
                    </button>
                </h3>
                <div id="panel-plot" class="accordion-collapse collapse" aria-labelledby="label-panel-plot">
                    <div class="accordion-body">
                        <div class="row">
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_select('cmap');" id="toggle-cmap" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-cmap">{{ gettext('parameter:colormap:label') }}</span>
                                    <select name="cmap" class="form-select" aria-label="{{ gettext('parameter:colormap:label') }}" aria-describedby="label-input-cmap" onchange="generate_url();" disabled>
                                        {% for colormap in colormaps %}
                                        <option value="{{ colormap }}"{% if colormap == settings.plot_spectrogram_colormap %} selected{% endif %}>
                                            {{ colormap }}
                                        </option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('cmin');" id="toggle-cmin" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-cmap">{{ gettext('parameter:colormap_min:label') }}</span>
                                    <input name="cmin" type="number" class="form-control" placeholder="{{ settings.plot_spectrogram_colormap_min }}" aria-label="{{ gettext('parameter:colormap_min:label') }}" aria-describedby="label-input-cmin" onchange="generate_url();" disabled>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('cmax');" id="toggle-cmax" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-cmap">{{ gettext('parameter:colormap_max:label') }}</span>
                                    <input name="cmax" type="number" class="form-control" placeholder="{{ settings.plot_spectrogram_colormap_max }}" aria-label="{{ gettext('parameter:colormap_max:label') }}" aria-describedby="label-input-cmax" onchange="generate_url();" disabled>
                                </div>
                            </div>
                        </div>

                        <div class="input-group mb-3">
                            <div class="input-group-text">
                                <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('fontsize');" id="toggle-fontsize" onchange="generate_url();">
                            </div>
                            <span class="input-group-text" id="label-input-fontsize">{{ gettext('parameter:fontsize:label') }}</span>
                            <input name="fontsize" type="number" class="form-control" placeholder="{{ settings.plot_font_size }}" aria-label="{{ gettext('parameter:fontsize:label') }}" aria-describedby="label-input-fontsize" onchange="generate_url();" disabled>
                            <span class="input-group-text">pt</span>
                        </div>

                        <div class="input-group mb-3">
                            <div class="input-group-text">
                                <input class="form-check-input mt-0" type="checkbox" onclick="toggle_select('grid');" id="toggle-grid" onchange="generate_url();">
                            </div>
                            <span class="input-group-text" id="label-input-grid">{{ gettext('parameter:grid:label') }}</span>
                            <select name="grid" class="form-select" aria-label="{{ gettext('parameter:grid:label') }}" aria-describedby="label-input-grid" onchange="generate_url();" disabled>
                                <option value="true"{% if settings.plot_spectrogram_grid %} selected{% endif %}>{{ gettext('yes') }}</option>
                                <option value="false"{% if settings.plot_spectrogram_grid %} selected{% endif %}>{{ gettext('no') }}</option>
                            </select>
                        </div>

                        <div class="input-group mb-3">
                            <div class="input-group-text">
                                <input class="form-check-input mt-0" type="checkbox" onclick="toggle_select('yinvert');" id="toggle-yinvert" onchange="generate_url();">
                            </div>
                            <span class="input-group-text" id="label-input-yinvert">{{ gettext('parameter:yinvert:label') }}</span>
                            <select name="yinvert" class="form-select" aria-label="{{ gettext('parameter:yinvert:label') }}" aria-describedby="label-input-yinvert" onchange="generate_url();" disabled>
                                <option value="true"{% if settings.plot_spectrogram_y_invert %} selected{% endif %}>{{ gettext('yes') }}</option>
                                <option value="false"{% if not settings.plot_spectrogram_y_invert %} selected{% endif %}>{{ gettext('no') }}</option>
                            </select>
                        </div>
                    </div>
                </div>
            </div>

            <div class="accordion-item">
                <h3 class="accordion-header" id="label-panel-image">
                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panel-image" aria-expanded="false" aria-controls="panel-image">
                        {{ gettext('Image configuration') }}
                    </button>
                </h3>
                <div id="panel-image" class="accordion-collapse collapse" aria-labelledby="label-panel-image">
                    <div class="accordion-body">

                        <div class="row">
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('width');" id="toggle-width" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-width">{{ gettext('parameter:width:label') }}</span>
                                    <input name="width" type="number" class="form-control" placeholder="{{ settings.plot_image_width }}" aria-label="{{ gettext('parameter:width:label') }}" aria-describedby="label-input-width" onchange="generate_url();" disabled>
                                    <span class="input-group-text">px</span>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('height');" id="toggle-height" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-height">{{ gettext('parameter:height:label') }}</span>
                                    <input name="height" type="number" class="form-control" placeholder="{{ settings.plot_image_height }}" aria-label="{{ gettext('parameter:height:label') }}" aria-describedby="label-input-height" onchange="generate_url();" disabled>
                                    <span class="input-group-text">px</span>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('dpi');" id="toggle-dpi" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-dpi">{{ gettext('parameter:dpi:label') }}</span>
                                    <input name="dpi" type="number" class="form-control" placeholder="{{ settings.plot_image_dpi }}" aria-label="{{ gettext('parameter:dpi:label') }}" aria-describedby="label-input-dpi" onchange="generate_url();" disabled>
                                    <span class="input-group-text">dpi</span>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_select('format');" id="toggle-format" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-format">{{ gettext('parameter:format:label') }}</span>
                                    <select name="format" class="form-select" aria-label="{{ gettext('parameter:format:label') }}" aria-describedby="label-input-format" onchange="generate_url();" disabled>
                                        <option value="png"{% if settings.plot_image_format == 'png' %} selected{% endif %}>PNG</option>
                                        <option value="jpg"{% if settings.plot_image_format == 'jpg' %} selected{% endif %}>JPG</option>
                                        <option value="pdf"{% if settings.plot_image_format == 'pdf' %} selected{% endif %}>PDF</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col">
                                <div class="input-group mb-3">
                                    <div class="input-group-text">
                                        <input class="form-check-input mt-0" type="checkbox" onclick="toggle_select('transparent');" id="toggle-transparent" onchange="generate_url();">
                                    </div>
                                    <span class="input-group-text" id="label-input-transparent">{{ gettext('parameter:transparent:label') }}</span>
                                    <select name="transparent" class="form-select" aria-label="{{ gettext('parameter:transparent:label') }}" aria-describedby="label-input-transparent" onchange="generate_url();" disabled>
                                        <option value="true"{% if settings.plot_image_transparent %} selected{% endif %}>{{ gettext('yes') }}</option>
                                        <option value="false"{% if settings.plot_image_transparent %} selected{% endif %}>{{ gettext('no') }}</option>
                                    </select>
                                </div>
                            </div>
                        </div>

                        <div class="input-group mb-3">
                            <div class="input-group-text">
                                <input class="form-check-input mt-0" type="checkbox" onclick="toggle_input('nodata');" id="toggle-nodata" onchange="generate_url();" checked>
                            </div>
                            <span class="input-group-text" id="label-input-nodata">{{ gettext('parameter:nodata:label') }}</span>
                            <input name="nodata" type="number" class="form-control" placeholder="204" aria-label="{{ gettext('parameter:nodata:label') }}" onchange="generate_url();" value="404">
                        </div>

                    </div>
                </div>
            </div>
        </div>
        <div class="card-footer">
            <div class="input-group mb-3">
                <input type="text" class="form-control" placeholder="" aria-label="URL" id="input-generated-url" readonly>
                <div class="input-group-append">
                    <button id="button-copy" class="btn btn-secondary" type="button" data-clipboard-target="#input-generated-url">
                        <i class="bi bi-clipboard-plus"></i>
                    </button>
                    <button id="button-run" class="btn btn-primary" type="button" onclick="run_url();">
                        <i class="bi bi-play-fill"></i>
                    </button>
                </div>
            </div>
        </div>
    </form>

    <h2>{{ gettext('Documentation') }}</h2>
    {{ panel('example', command) }}

    <h3>Usage</h3>
    <pre><code>/{{ command }}? (channel-options) (date-range-options) [image-options] [plot-options] [nodata=404]

{{ gettext('where') }} :
channel-options      ::  (network=&lt;network&gt;) (station=&lt;station&gt;) (location=&lt;location&gt;) (channel=&lt;channel&gt;)
date-range-options   ::  (starttime=&lt;date&gt;) (endtime=&lt;date&gt;)
image-options        ::  [dpi=&lt;dots per inch&gt;] [width=&lt;pixels&gt;] [height=&lt;pixels&gt;]
                         [format=&lt;png|jpg|pdf&gt;] [transparent=&lt;true|false&gt;]
plot-options         ::  [cmap=<>] [cmin=<>] [cmax=<>]
                         [fontsize=<>] [grid=&lt;true|false&gt;] [yinvert=&lt;true|false&gt;]

(..) {{ gettext('mandatory') }}
[..] {{ gettext('optional') }}</code></pre>

    <h3>{{ gettext('Parameters') }}</h3>
    {% include 'seedpsd:api/templates/snippets/doc/datasource.jinja2' %}
    {% include 'seedpsd:api/templates/snippets/doc/timeperiod.jinja2' %}

    <h4>{{ gettext('Image configuration') }}</h4>
    <table class="table table-striped">
        <thead>
            <tr>
                <th>{{ gettext('Parameter') }}</th>
                <th>{{ gettext('Alias') }}</th>
                <th>{{ gettext('Default') }}</th>
                <th>{{ gettext('Description') }}</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>width</td>
                <td>plot.width</td>
                <td>{{ settings.plot_image_width }}</td>
                <td>{{ gettext('parameter:width:description') }}</td>
            </tr>
            <tr>
                <td>height</td>
                <td>plot.height</td>
                <td>{{ settings.plot_image_height }}</td>
                <td>{{ gettext('parameter:height:description') }}</td>
            </tr>
            <tr>
                <td>dpi</td>
                <td></td>
                <td>{{ settings.plot_image_dpi }}</td>
                <td>{{ gettext('parameter:dpi:description') }}</td>
            </tr>

            <tr>
                <td>format</td>
                <td></td>
                <td>{{ settings.plot_image_format }}</td>
                <td>{{ gettext('parameter:format:description') }}</td>
            </tr>

            <tr>
                <td>nodata</td>
                <td></td>
                <td>204</td>
                <td>{{ gettext('parameter:nodata:description') }}</td>
            </tr>

            <tr>
                <td>transparent</td>
                <td></td>
                <td>{{ settings.plot_image_transparent }}</td>
                <td>{{ gettext('parameter:transparent:description') }}</td>
            </tr>
        </tbody>
    </table>

    <h4>{{ gettext('Graphical options') }}</h4>
    <table class="table table-striped">
        <thead>
            <tr>
                <th>{{ gettext('Parameter') }}</th>
                <th>{{ gettext('Alias') }}</th>
                <th>{{ gettext('Default') }}</th>
                <th>{{ gettext('Description') }}</th>
                <th>ObsPy</th>
            </tr>
        </thead>
        <tbody>

            <tr>
                <td>colormap</td>
                <td>cmap, plot.color.palette</td>
                <td>{{ settings.plot_spectrogram_colormap }}</td>
                <td><a href="https://matplotlib.org/stable/tutorials/colors/colormaps.html" target="_blank">{{ gettext('parameter:colormap:description') }}</a></td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.spectral_estimation.PPSD.plot.html#obspy.signal.spectral_estimation.PPSD.plot_spectrogram" target="_blank">cmap</a></td>
            </tr>

            <tr>
                <td>colormap_min</td>
                <td>cmin</td>
                <td>{{ settings.plot_spectrogram_colormap_min }}</td>
                <td>{{ gettext('parameter:colormap_min:description') }}</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.spectral_estimation.PPSD.plot.html#obspy.signal.spectral_estimation.PPSD.plot_spectrogram" target="_blank">clim</a></td>
            </tr>

            <tr>
                <td>colormap_max</td>
                <td>cmax</td>
                <td>{{ settings.plot_spectrogram_colormap_max }}</td>
                <td>{{ gettext('parameter:colormap_max:description') }}</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.spectral_estimation.PPSD.plot.html#obspy.signal.spectral_estimation.PPSD.plot_spectrogram" target="_blank">clim</a></td>
            </tr>

            <tr>
                <td>font_size</td>
                <td>fontsize, plot.labelfont.size</td>
                <td>{{ settings.plot_font_size }}</td>
                <td>{{ gettext('parameter:fontsize:description') }}</td>
                <td></td>
            </tr>

            <tr>
                <td>grid</td>
                <td></td>
                <td>{{ settings.plot_spectrogram_grid }}</td>
                <td>{{ gettext('parameter:grid:description') }}</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.spectral_estimation.PPSD.plot.html#obspy.signal.spectral_estimation.PPSD.plot_spectrogram" target="_blank">grid</a></td>
            </tr>

            <tr>
                <td>y_invert</td>
                <td>yinvert, plot.frequency.invert</td>
                <td>{{ settings.plot_spectrogram_y_invert }}</td>
                <td>{{ gettext('parameter:y_invert:description') }}</td>
                <td></td>
            </tr>
        </tbody>
    </table>

{% endblock %}
